#include <Windows.h>
#include <atlbase.h>
#include <streams.h>
#include "MIDL\IMemoryRenderer.h"
#include "MemoryRendererAllocator.h"
#include "MemoryRendererInputPin.h"
#include "MemoryRenderer.h"

// CX^X֐

CUnknown* CreateInstance( LPUNKNOWN pUnkOuter, HRESULT *phr )
{
	if( pUnkOuter != NULL )
	{
		*phr = CLASS_E_NOAGGREGATION;
		return NULL;
	}

	MemoryRenderer* pMR = new MemoryRenderer( NAME("MemoryRenderer"), pUnkOuter, phr );

	if( pMR == NULL )
		*phr = E_OUTOFMEMORY;

	return pMR;
}

// t@Ng

#pragma region [ tB^̐錾 ]
//-----------------
// Ql: http://msdn.microsoft.com/ja-jp/library/cc353819.aspx


// fBA^Cv
const AMOVIESETUP_MEDIATYPE pPinMediaType_In[] =
{
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_RGB32 }
};

// s
const AMOVIESETUP_PIN pPinInfo[] =
{
	{
		L"",					// p~is̖Oj
		TRUE,					// TRUE ̏ꍇAtB^͂̃s̓͂_O (̓sɊYBo̓s̏ꍇ͏ FALSE)B
		FALSE,					// TRUE ̏ꍇÃs͏o̓sƂȂBFALSE ̏ꍇA̓sƂȂB
		FALSE,					// TRUE ̏ꍇAtB^̃s̃CX^X 1 ȂƂB
		FALSE,					// TRUE ̏ꍇAtB^̎ނ̃s̃CX^X𕡐쐬łB
		&CLSID_NULL,			// p~ĩsڑtB^̃NXʎq (CLSID) j
		NULL,					// p~ĩsڑs̖Oj
		1,						// ̃sT|[g郁fBA^CvB
		pPinMediaType_In		// ̃sT|[g郁fBA^Cv̔zւ̃|C^B
	},
};

// tB^ݒ
const AMOVIESETUP_FILTER mFilterInfo =
{
	&CLSID_MemoryRenderer,		// tB^̃NXIDB
	L"MemoryRenderer",			// tB^B
	MERIT_DO_NOT_USE,			// bglB
	1,							// s̐B
	pPinInfo					// sւ̃|C^B
};
//-----------------
#pragma endregion

#pragma region [ tB^pt@Ngev[g̐錾 ]
//-----------------
// Ql: http://msdn.microsoft.com/ja-jp/library/cc353831.aspx

CFactoryTemplate g_Templates[] = 
{
	{
		L"MemoryRenderer",					// tB^̖OB
		&CLSID_MemoryRenderer,				// tB^ CLSID ւ̃|C^B
		(LPFNNewCOMObject) CreateInstance,	// tB^̃CX^X쐬֐ւ̃|C^B
		NULL,								// DLLGg|CgĂяoiṕj֐̃|C^B
		&mFilterInfo						// AMOVIESETUP_FILTER \̂ւ̃|C^B
	}
};
int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);
//-----------------
#pragma endregion

#pragma region [ WXgւ̓o^E ]
//-----------------
STDAPI DllRegisterServer()
{
	return AMovieDllRegisterServer2( TRUE );
}

STDAPI DllUnregisterServer()
{
	return AMovieDllRegisterServer2( FALSE );
}
//-----------------
#pragma endregion
